<template>
  <div>
    <h2 id="page-heading" data-cy="CaloriaHeading">
      <span v-text="$t('gatewayApp.manillaCaloria.home.title')" id="caloria-heading">Calorias</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.manillaCaloria.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'CaloriaCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-caloria"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.manillaCaloria.home.createLabel')"> Create a new Caloria </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && calorias && calorias.length === 0">
      <span v-text="$t('gatewayApp.manillaCaloria.home.notFound')">No calorias found</span>
    </div>
    <div class="table-responsive" v-if="calorias && calorias.length > 0">
      <table class="table table-striped" aria-describedby="calorias">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('caloriasActivas')">
              <span v-text="$t('gatewayApp.manillaCaloria.caloriasActivas')">Calorias Activas</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'caloriasActivas'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('descripcion')">
              <span v-text="$t('gatewayApp.manillaCaloria.descripcion')">Descripcion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'descripcion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaRegistro')">
              <span v-text="$t('gatewayApp.manillaCaloria.fechaRegistro')">Fecha Registro</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaRegistro'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.manillaCaloria.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="caloria in calorias" :key="caloria.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'CaloriaView', params: { caloriaId: caloria.id } }">{{ caloria.id }}</router-link>
            </td>
            <td>{{ caloria.caloriasActivas }}</td>
            <td>{{ caloria.descripcion }}</td>
            <td>{{ caloria.fechaRegistro ? $d(Date.parse(caloria.fechaRegistro), 'short') : '' }}</td>
            <td>
              {{ caloria.user ? caloria.user.login : '' }}
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'CaloriaView', params: { caloriaId: caloria.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'CaloriaEdit', params: { caloriaId: caloria.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(caloria)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.manillaCaloria.delete.question" data-cy="caloriaDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-caloria-heading" v-text="$t('gatewayApp.manillaCaloria.delete.question', { id: removeId })">
          Are you sure you want to delete this Caloria?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-caloria"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeCaloria()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./caloria.component.ts"></script>
